# -*- coding: utf-8 -*-
"""
Запускать после файлов 04-mixture_2.py, 05-mixture_3.py.
"""

figsize(11.0, 4)
std_trace = mcmc.trace("s")[:]

_i = [1, 2, 3, 0]
for i in range(2):
    plt.subplot(2, 2, _i[2 * i])
    plt.title("Апостериорное распределение центра %d" % i)
    plt.hist(center_trace[:, i], color=colors[i], bins=30,
             histtype="stepfilled")

    plt.subplot(2, 2, _i[2 * i + 1])
    plt.title("Апостериорное распределение дисперсии %d" % i)
    plt.hist(std_trace[:, i], color=colors[i], bins=30,
             histtype="stepfilled")
    # plt.autoscale(tight=True)

plt.tight_layout()

figsize(12, 6)
plt.figure()

import matplotlib as mpl

plt.cmap = mpl.colors.ListedColormap(colors)
plt.imshow(mcmc.trace("assignment")[::400, np.argsort(data)],
       cmap=plt.cmap, aspect=.4, alpha=.9)
plt.xticks(np.arange(0, data.shape[0], 40),
       ["%.2f" % s for s in np.sort(data)[::40]])
plt.ylabel("Пример из апостериорного\nраспределения")
plt.xlabel("значение $i$-ой точки данных")
plt.title("Апостериорные метки точек данных")

plt.figure()

cmap = mpl.colors.LinearSegmentedColormap.from_list("BMH", colors)
assign_trace = mcmc.trace("assignment")[:]
plt.scatter(data, 1 - assign_trace.mean(axis=0), cmap=cmap,
        c=assign_trace.mean(axis=0), s=50)
plt.ylim(-0.05, 1.05)
plt.xlim(35, 300)
plt.title("Вероятность принадлежности значения кластеру 0")
plt.ylabel("Вероятность")
plt.xlabel("Значение")

plt.figure()
norm = stats.norm
x = np.linspace(20, 300, 500)
posterior_center_means = center_trace.mean(axis=0)
posterior_std_means = std_trace.mean(axis=0)
posterior_p_mean = mcmc.trace("p")[:].mean()

plt.hist(data, bins=20, histtype="step", normed=True, color="k",
     lw=2, label="Гистограмма данных")
y = posterior_p_mean * norm.pdf(x, loc=posterior_center_means[0],
                                scale=posterior_std_means[0])
plt.plot(x, y, label="Кластер 0 (средние апостериорные значения)", lw=3)
plt.fill_between(x, y, color=colors[1], alpha=0.3)

y = (1-posterior_p_mean) * norm.pdf(x, loc=posterior_center_means[1],
                                      scale=posterior_std_means[1])
plt.plot(x, y, label="Кластер 1 (средние апостериорные значения)", lw=3)
plt.fill_between(x, y, color=colors[0], alpha=0.3)

plt.legend(loc="upper left")
plt.title("Визуализация кластеров используя средние апостериорные значения")

plt.figure()
plt.scatter(std_trace[:,0],std_trace[:, 1], alpha=0.1)

norm_pdf = stats.norm.pdf
p_trace = mcmc.trace("p")[:]
x = 155

v = p_trace * norm_pdf(x, loc=center_trace[:, 0], scale=std_trace[:, 0]) > \
    (1 - p_trace) * norm_pdf(x, loc=center_trace[:, 1], scale=std_trace[:, 1])

print("Вероятность принадлежности кластеру 0:", v.mean())

